# Config Grub/WarX-16 - functions.cfg
# Copyright (C) 2018 WarX-16 <contact@warx-16.org>.
# https://www.warx-16.org
#
# Config Grub/WarX-16 is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# Config Grub/WarX-16 is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Config Grub/WarX-16.  If not, see <https://www.gnu.org/licenses/>.
#
# Certain part of Config Grub/WarX-16 was inspired by Super Grub Disk
# ( Adrian Gibanel Lopez - Jordan Uggla - https://www.supergrubdisk.org/ )


############## PROMPT ##################################################

function prompt {
	check_time
	echo -n "[${time_hour}:${time_min}:${time_sec}] grub@${g_dev}> "
}

function menu_continue {
	echo ''
	echo -n '				'$"Press [ Enter ] to continue"' '
	read mcont
}


############## PAGER ###################################################

function set_pag {
	set pager_old="${pager}"
	set pager=1
}

function unset_pag {
	set pager_old="${pager}"
	set pager=0
}

function reset_pag {
	set pager="${pager_old}"
	unset pager_old
}


############## VERBOSE #################################################

function header {
	check_time
	echo '========================================================================'
	echo "[${time_hour}:${time_min}:${time_sec}]--[ $@ ]"
	echo ''
}

function footer {
	echo '------------------------------------------------------------------------'
	echo ''
}

function say {
	check_time
	echo "[${time_hour}:${time_min}:${time_sec}] [ $@ ]"
}

function err {
	check_time
	echo "[${time_hour}:${time_min}:${time_sec}] [ "$"ERROR"" ]-[ $@ ]-[ ! ]"
}

function info {
	if [ -n "${verb}" -a "${verb}" != 'off' ]; then
		check_time
		echo "[${time_hour}:${time_min}:${time_sec}] [ "$"INFO"" ]-[ $@ ]"
	fi
}

function debug {
	if [ "${verb}" = 'debug' ]; then
		check_time
		echo "[${time_hour}:${time_min}:${time_sec}] [ "$"DEBUG"" ]-[ $@ ]"
	fi
}

function pause {
	if [ "${verb}" = 'on' ]; then
		if [ -n "$1" ]; then
			sleep -v -i "$1"
		fi
		echo ''
	elif [ "${verb}" = 'debug' ]; then
		menu_continue
	fi
}

############## MODULE ##################################################

function ins_mod {
	for mod in $@; do
		insmod "${mod}"
		debug $"module loaded:"" ${mod}"
	done
	unset mod
}

function rm_mod {
	for mod in $@; do
		rmmod "${mod}"
		debug $"module unloaded:"" ${mod}"
	done
	unset mod
}

function load_font {
	for ft in $@; do
		loadfont "${ft}"
		debug $"font loaded:"" ${ft}"
	done
	unset ft
}


############## MODULE ##################################################

#~ function configfile {
#~ set chosen=''
#~ configfile "$1"
#~ }

#~ function process {
#~ set opt_cfg="$1"
#~ source "${opt_cfg}"
#~ menuentry --class="${opt_icon}" "${opt_title}" "${opt_cfg}" {
#~ set chosen=''; export chosen
#~ set cfgs="${2}"; export cfgs
#~ configfile "${G_PATH}/tools/process.cfg"
#~ }
#~ unset opt_icon    # force to forget icone class
#~ }

